package jesse.keeblarcraft.GuiMgr.ShopKeeper;

import jesse.keeblarcraft.GuiMgr.ScreenHandlerRegistration;
import jesse.keeblarcraft.Utils.CustomSlot;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.entity.player.PlayerInventory;
import net.minecraft.item.ItemStack;
import net.minecraft.screen.ScreenHandler;
import net.minecraft.screen.slot.Slot;
import net.minecraft.text.Text;
import net.minecraft.village.Merchant;
import net.minecraft.village.MerchantInventory;
import net.minecraft.village.SimpleMerchant;
import net.minecraft.village.TradeOfferList;

import java.util.HashMap;
import java.util.Map;

public class ShopKeeperHandler extends ScreenHandler {
    private Merchant merchant;
    private MerchantInventory merchantInventory;
    private boolean canRefreshTrades = false;
    private boolean isLeveledMerchant = false;
    private int levelAmount = 0;
    private int merchantExperience = 0;
    private Map<Text, Integer> slotIdByName = new HashMap<>();
    ShopKeeperSlots allSlots = new ShopKeeperSlots();

    public ShopKeeperHandler(int syncId, PlayerInventory playerInventory) {
        this(syncId, playerInventory, new SimpleMerchant(playerInventory.player));
    }

    public ShopKeeperHandler(int syncId, PlayerInventory playerInventory, Merchant merchant) {
        super(ScreenHandlerRegistration.SHOP_KEEPER_HANDLER_SCREEN_HANDLER_TYPE, syncId);
        this.merchant = merchant;
        this.merchantInventory = new MerchantInventory(merchant);
        RegisterSlots();
        // Add slots below
//        this.addSlot(new Slot(this.merchantInventory, 0, 136, 37));
//        this.addSlot(new CustomSlot(this.merchantInventory, 0, 136, 37), Text.of("test"));
    }

    public void RegisterSlots() {
        CustomSlot slotOne = new CustomSlot(this.merchantInventory, 0, 136, 37);


        allSlots.AddSlot("add_item_menu", "add_item_slot", slotOne);
        this.addSlot(slotOne);
    }

    public void showSlot(String menuName, String slotName) {
        allSlots.ShowSlot(menuName, slotName);
    }

    public void hideSlot(String menuName, String slotName) {
        allSlots.HideSlot(menuName, slotName);
    }

    public CustomSlot getSlot(Text name) {
        System.out.println("Printing slot map");
        for (Slot slot : super.slots) {
            System.out.println("Found slot with id: " + slot.id);
        }

        System.out.println("Printing self stored map");
        for (Map.Entry<Text, Integer> entry : this.slotIdByName.entrySet()) {
            System.out.println("entry set id value: " + "K: " + entry.getKey() + " -> V: " + entry.getValue());
        }

        return (CustomSlot) super.getSlot(slotIdByName.get(name));
    }

    public void SetOffers(TradeOfferList offers) {
        this.merchant.setOffersFromServer(offers);
    }

    public void SetExperienceLevel(int xp) {
        this.merchantExperience = xp;
    }

    public void SetLevelProgress(int level) {
        this.levelAmount = level;
    }

    public void SetLeveled(boolean leveled) {
        this.isLeveledMerchant = leveled;
    }

    public void SetCanRefreshTrades(boolean isRefreshable) {
        this.canRefreshTrades = isRefreshable;
    }

    @Override
    public ItemStack quickMove(PlayerEntity player, int slot) {
        return null;
    }

    // Called every tick
    @Override
    public boolean canUse(PlayerEntity player) {
        return true;
    }
}
